#!/bin/bash
PYVMOMIPATH=
for bldType in opt beta obj ; do
   vmomiPath=../../../build/build/LIBRARIES/vmodl/generic/${bldType}/
   if [ -d ${vmomiPath} ]; then
      PYVMOMIPATH=${vmomiPath}
      break
   fi
done
if [ ! -d "$PYVMOMIPATH" ] ; then
   echo "Must build pyVmomi first"
   exit
fi
echo "Using pyVmomi in ${PYVMOMIPATH}"

PYVIMPATH=../pyVim
# Setup build path in tmp (to avoid my own name shows up in executable)
buildPath=/tmp/esxcli
rm -rf ${buildPath}
mkdir -p ${buildPath}/pyVmomi
cp -f ${PYVMOMIPATH}/pyVmomi/*.py ${buildPath}/pyVmomi
mkdir -p ${buildPath}/pyVim
cp -f ${PYVIMPATH}/sso.py ${buildPath}/pyVim
cp -f ${PYVIMPATH}/__init__.py ${buildPath}/pyVim
cp -f *.py ${buildPath}

# Build executable
pushd ${buildPath}
pythonRoot=/build/toolchain/lin32/python-2.6.1
${pythonRoot}/bin/python cx_freeze_setup.py build_exe -b "build/lin32" -i `pwd`/cx_freeze_console.py
/usr/bin/env cp -f ${pythonRoot}/lib/libpython2.6.so.1.0 build/lin32/
/usr/bin/env cp -f /build/toolchain/lin32/python-openssl-2.6.1-0.9.8r/* build/lin32/
popd

# Do the diff
echo "diff ${buildPath}/build/lin32/ package/lin32/"
diff ${buildPath}/build/lin32/ package/lin32/
