#!/usr/bin/python

from __future__ import print_function

import sys
from pyVmomi import Vim
from pyVmomi import VmomiSupport
from pyVim.connect import Connect, Disconnect
from pyVim.task import WaitForTask
from pyVim import folder
from pyVim import vm
import time
import atexit

def main():
    # Process command line
    host = "jairam-esx"
    if len(sys.argv) > 1:
       host = sys.argv[1]

    # Connect
    si = Connect(host)
    atexit.register(Disconnect, si)

    vm1 = vm.CreateQuickDummy("ACPITest")
    print(vm1.GetConfig().GetDefaultPowerOps().GetStandbyAction())

    configspec = Vim.Vm.ConfigSpec()
    defaultPowerOpInfo = Vim.Vm.DefaultPowerOpInfo()
    defaultPowerOpInfo.SetStandbyAction("Checkpoint")
    configspec.SetPowerOpInfo(defaultPowerOpInfo);
    task = vm1.Reconfigure(configspec)
    WaitForTask(task)
    print(vm1.GetConfig().GetDefaultPowerOps().GetStandbyAction())
    time.sleep(1)
    vm.PowerOn(vm1)
    time.sleep(1)
    vm.PowerOff(vm1)
    time.sleep(1)

    configspec = Vim.Vm.ConfigSpec()
    defaultPowerOpInfo = Vim.Vm.DefaultPowerOpInfo()
    defaultPowerOpInfo.SetStandbyAction("PowerOnSuspend")
    configspec.SetPowerOpInfo(defaultPowerOpInfo);
    task = vm1.Reconfigure(configspec)
    WaitForTask(task)
    print(vm1.GetConfig().GetDefaultPowerOps().GetStandbyAction())

    time.sleep(1)
    vm.PowerOn(vm1)
    time.sleep(1)
    vm.PowerOff(vm1)
    time.sleep(1)

    configspec = Vim.Vm.ConfigSpec()
    defaultPowerOpInfo = Vim.Vm.DefaultPowerOpInfo()
    defaultPowerOpInfo.SetStandbyAction("Checkpoint")
    configspec.SetPowerOpInfo(defaultPowerOpInfo);
    task = vm1.Reconfigure(configspec)
    WaitForTask(task)
    print(vm1.GetConfig().GetDefaultPowerOps().GetStandbyAction())

    time.sleep(1)
    vm.PowerOn(vm1)
    time.sleep(1)
    vm.PowerOff(vm1)
    time.sleep(1)

    task = vm1.Destroy()
    WaitForTask(task)


# Start program
if __name__ == "__main__":
    main()
