#!/usr/bin/python

import sys
from pyVmomi import VmomiSupport, Vmodl, Vim
from pyVim.connect import Connect, Disconnect
import atexit

def main():
    # Process command line
    host = "jairam-esx"
    if len(sys.argv) > 1:
       host = sys.argv[1]

    # Connect
    si = Connect(host)
    atexit.register(Disconnect, si)
    
    # Array of selection specs
    sspecs = []

    # Selection spec 1
    sspecs.append(Vmodl.Query.PropertyCollector.SelectionSpec("visitFolders"))
    
    # Traversal spec for host folder
    trspec = Vmodl.Query.PropertyCollector.TraversalSpec()
    trspec.SetName("visitHostFolder")
    trspec.SetPath("hostFolder")
    trspec.SetType("Datacenter")
    trspec.SetSkip(False)
    trspec.SetSelectSet([Vmodl.Query.PropertyCollector.SelectionSpec("visitFolders")])
    sspecs.append(trspec)

    # Traversal spec for vm
    vmtrspec = Vmodl.Query.PropertyCollector().TraversalSpec()
    vmtrspec.SetName("visitVmFolder")
    vmtrspec.SetPath("vmFolder")
    vmtrspec.SetType("Datacenter")
    vmtrspec.SetSkip(False)
    vmtrspec.SetSelectSet([Vmodl.Query.PropertyCollector.SelectionSpec("visitFolders")])
    sspecs.append(vmtrspec)

    # Compute resource
    crtrspec = Vmodl.Query.PropertyCollector().TraversalSpec()
    crtrspec.SetName("visitComputeResource")
    crtrspec.SetPath("host")
    crtrspec.SetType("ComputeResource")
    crtrspec.SetSkip(False)
    crtrspec.SetSelectSet([])
    sspecs.append(crtrspec)

    # Uber spec
    tr = Vmodl.Query.PropertyCollector().TraversalSpec()
    tr.SetName("visitFolders")
    tr.SetType("Folder")
    tr.SetPath("childEntity")
    tr.SetSkip(False)
    tr.SetSelectSet(sspecs)

    # Next, create the property specification.
    p1 = Vmodl.Query.PropertyCollector.PropertySpec()
    p1.SetType("vim.ManagedEntity")
    p1.SetAll(True)
    p2 = Vmodl.Query.PropertyCollector.PropertySpec()
    p2.SetType("vim.Folder")
    p2.SetAll(True)
    p3 = Vmodl.Query.PropertyCollector.PropertySpec()
    p3.SetType("vim.Datacenter")
    p3.SetAll(True)
    p4 = Vmodl.Query.PropertyCollector.PropertySpec()
    p4.SetType("vim.ComputeResource")
    p4.SetAll(True)
    p5 = Vmodl.Query.PropertyCollector.PropertySpec()
    p5.SetType("vim.ResourcePool")
    p5.SetAll(True)
    p6 = Vmodl.Query.PropertyCollector.PropertySpec()
    p6.SetType("vim.HostSystem")
    p6.SetAll(True)
    p7 = Vmodl.Query.PropertyCollector.PropertySpec()
    p7.SetType("vim.VirtualMachine")
    p7.SetAll(True)

    propspecs = [p1, p2, p3, p4, p5, p6, p7]

    filterSpec = Vmodl.Query.PropertyCollector.PropertyFilterSpec()
    


# Start program
if __name__ == "__main__":
    main()
