#!/usr/bin/python

###
### Test description:
###
### Rename a powered on virtual machine.
###

from __future__ import print_function

import sys
from pyVmomi import Vim
from pyVmomi import VmomiSupport
from pyVim.connect import Connect, Disconnect
from pyVim.task import WaitForTask
from pyVim import folder
from pyVim import vm
import atexit

def main():
    # Process command line
    host = "jairam-esx"
    if len(sys.argv) > 1:
       host = sys.argv[1]

    # Connect
    try:
        si = Connect(host)
        atexit.register(Disconnect, si)
	vm.CreateQuickDummy("Rename-PoweredOn")
	v1 = folder.Find("Rename-PoweredOn")
	print("Created a dummy")
	vm.PowerOn(v1)
	task = v1.Rename("Renamed-VM")
	if WaitForTask(task) == "error":
	   raise task.GetInfo().GetError()
	newname = v1.GetConfig().GetName()
	if newname != "Renamed-VM":
	   print("Failed to rename: Name is: %s" % newname)
	print("Found new name: %s" % newname)
	vm.PowerOff(v1)
	task = v1.Destroy()
	WaitForTask(task)

    except Exception as e:
	print("Failed test due to exception: %s" % e)


# Start program
if __name__ == "__main__":
    main()
